diff --git a/src/backend/access/transam/xact.c b/src/backend/access/transam/xact.c
index 117fdab..0552532 100644
--- a/src/backend/access/transam/xact.c
+++ b/src/backend/access/transam/xact.c
@@ -40,6 +40,7 @@
 #include "storage/fd.h"
 #include "storage/lmgr.h"
 #include "storage/procarray.h"
+#include "storage/sinval.h"
 #include "storage/sinvaladt.h"
 #include "storage/smgr.h"
 #include "utils/combocid.h"
@@ -136,10 +137,13 @@ typedef struct TransactionStateData
 	ResourceOwner curTransactionOwner;	/* my query resources */
 	TransactionId *childXids;	/* subcommitted child XIDs, in XID order */
 	int			nChildXids;		/* # of subcommitted child XIDs */
+	int			nReportedChildXids;
 	int			maxChildXids;	/* allocated size of childXids[] */
 	Oid			prevUser;		/* previous CurrentUserId setting */
 	bool		prevSecDefCxt;	/* previous SecurityDefinerContext setting */
 	bool		prevXactReadOnly;		/* entry-time xact r/o state */
+	bool		startedInRecovery;	/* did we start in recovery? */
+	bool		reportedXid;
 	struct TransactionStateData *parent;		/* back link to parent */
 } TransactionStateData;
 
@@ -164,10 +168,13 @@ static TransactionStateData TopTransactionStateData = {
 	NULL,						/* cur transaction resource owner */
 	NULL,						/* subcommitted child Xids */
 	0,							/* # of subcommitted child Xids */
+	0,							/* # of reported child Xids */
 	0,							/* allocated size of childXids[] */
 	InvalidOid,					/* previous CurrentUserId setting */
 	false,						/* previous SecurityDefinerContext setting */
 	false,						/* entry-time xact r/o state */
+	false,						/* startedInRecovery */
+	false,						/* reportedXid */
 	NULL						/* link to parent state block */
 };
 
@@ -211,6 +218,11 @@ static bool forceSyncCommit = false;
 static MemoryContext TransactionAbortContext = NULL;
 
 /*
+ * Local state to optimise recovery conflict resolution
+ */
+static	TransactionId	latestRemovedXid = InvalidTransactionId;
+
+/*
  * List of add-on start- and end-of-xact callbacks
  */
 typedef struct XactCallbackItem
@@ -275,6 +287,9 @@ static const char *BlockStateAsString(TBlockState blockState);
 static const char *TransStateAsString(TransState state);
 
 
+static TransactionId *xactGetUnreportedChildren(int threshold, int *nxids);
+static TransactionId *xactCollectUnreportedChildren(TransactionState s, TransactionId *xids);
+
 /* ----------------------------------------------------------------
  *	transaction state accessors
  * ----------------------------------------------------------------
@@ -393,6 +408,9 @@ AssignTransactionId(TransactionState s)
 	bool		isSubXact = (s->parent != NULL);
 	ResourceOwner currentOwner;
 
+	if (RecoveryInProgress())
+		elog(ERROR, "cannot assign TransactionIds during recovery");
+
 	/* Assert that caller didn't screw up */
 	Assert(!TransactionIdIsValid(s->transactionId));
 	Assert(s->state == TRANS_INPROGRESS);
@@ -436,8 +454,58 @@ AssignTransactionId(TransactionState s)
 	}
 	PG_END_TRY();
 	CurrentResourceOwner = currentOwner;
-}
 
+	/*
+	 * Every 64th assigned transaction id, within the top-level transaction,
+	 * issues a WAL record with the top-level xid and all the subxids not
+	 * yet WAL-logged.
+	 * This is only needed to limit the shared memory usage of a hot standby
+	 * server. In hot standby, the list of running transactions in the master
+	 * is kept in a fixed size UnobservedXids array, and we reserve
+	 * 64 * max_connections slots there. As soon as the standby server knows
+	 * that a transaction is a subtransaction, and knows its parent, it
+	 * can mark the subtransaction in pg_subtrans, and remove the entry from
+	 * the unobserved xids array, making room for new entries.
+	 *
+	 * XXX: We don't actually keep track of the parent of each subtransaction,
+	 * but only of the top-level transaction that each subxact belongs to.
+	 * I think that's enough, but perhaps it would be better to store the
+	 * exact relationships for debugging purposes.
+	 */
+	if (isSubXact)
+	{
+		int nchildren;
+		TransactionId *children;
+		children = xactGetUnreportedChildren(64, &nchildren);
+
+		if (children != NULL)
+		{
+			XLogRecData rdata[2];
+			xl_xact_assignment	xlrec;
+
+			xlrec.xtop = GetTopTransactionIdIfAny();
+			Assert(TransactionIdIsValid(xlrec.xtop));
+
+			elog(trace_recovery(DEBUG2),
+				 "AssignTransactionId xtop %u nest %d hasParent %s",
+				 xlrec.xtop,
+				 GetCurrentTransactionNestLevel(),
+				 isSubXact ? "t" : "f");
+
+			rdata[0].data = (char *) (&xlrec);
+			rdata[0].len = MinSizeOfXactAssignment;
+			rdata[0].buffer = InvalidBuffer;
+			rdata[0].next = &rdata[1];
+
+			rdata[1].data = (char *) children;
+			rdata[1].len = sizeof(TransactionId) * nchildren;
+			rdata[1].buffer = InvalidBuffer;
+			rdata[1].next = NULL;
+
+			(void) XLogInsert(RM_XACT_ID, XLOG_XACT_ASSIGNMENT, rdata);
+		}
+	}
+}
 
 /*
  *	GetCurrentSubTransactionId
@@ -597,6 +665,16 @@ TransactionIdIsCurrentTransactionId(TransactionId xid)
 	return false;
 }
 
+/*
+ *	TransactionStartedDuringRecovery, used during index scans
+ */
+bool
+TransactionStartedDuringRecovery(void)
+{
+	TransactionState s = CurrentTransactionState;
+
+	return s->startedInRecovery;
+}
 
 /*
  *	CommandCounterIncrement
@@ -822,11 +900,15 @@ RecordTransactionCommit(void)
 	bool		haveNonTemp;
 	int			nchildren;
 	TransactionId *children;
+	int			nmsgs;
+	SharedInvalidationMessage *invalMessages = NULL;
+	bool		RelcacheInitFileInval;
 
 	/* Get data needed for commit record */
 	nrels = smgrGetPendingDeletes(true, &rels, &haveNonTemp);
 	nchildren = xactGetCommittedChildren(&children);
-
+	nmsgs = xactGetCommittedInvalidationMessages(&invalMessages,
+												 &RelcacheInitFileInval);
 	/*
 	 * If we haven't been assigned an XID yet, we neither can, nor do we want
 	 * to write a COMMIT record.
@@ -860,7 +942,7 @@ RecordTransactionCommit(void)
 		/*
 		 * Begin commit critical section and insert the commit XLOG record.
 		 */
-		XLogRecData rdata[3];
+		XLogRecData rdata[4];
 		int			lastrdata = 0;
 		xl_xact_commit xlrec;
 
@@ -868,6 +950,19 @@ RecordTransactionCommit(void)
 		BufmgrCommit();
 
 		/*
+		 * Set flags required for recovery processing of commits.
+		 * Nothing too critical here that we would want to include this
+		 * within the critical section following.
+		 */
+		xlrec.xinfo = 0;
+		if (AtEOXact_Database_FlatFile_Update_Needed())
+			xlrec.xinfo |= XACT_COMPLETION_UPDATE_DB_FILE;
+		if (AtEOXact_Auth_FlatFile_Update_Needed())
+			xlrec.xinfo |= XACT_COMPLETION_UPDATE_AUTH_FILE;
+		if (RelcacheInitFileInval)
+			xlrec.xinfo |= XACT_COMPLETION_UPDATE_RELCACHE_FILE;
+
+		/*
 		 * Mark ourselves as within our "commit critical section".	This
 		 * forces any concurrent checkpoint to wait until we've updated
 		 * pg_clog.  Without this, it is possible for the checkpoint to set
@@ -891,6 +986,8 @@ RecordTransactionCommit(void)
 		xlrec.xact_time = xactStopTimestamp;
 		xlrec.nrels = nrels;
 		xlrec.nsubxacts = nchildren;
+		xlrec.nmsgs = nmsgs;
+
 		rdata[0].data = (char *) (&xlrec);
 		rdata[0].len = MinSizeOfXactCommit;
 		rdata[0].buffer = InvalidBuffer;
@@ -912,6 +1009,15 @@ RecordTransactionCommit(void)
 			rdata[2].buffer = InvalidBuffer;
 			lastrdata = 2;
 		}
+		/* dump shared cache invalidation messages */
+		if (nmsgs > 0)
+		{
+			rdata[lastrdata].next = &(rdata[3]);
+			rdata[3].data = (char *) invalMessages;
+			rdata[3].len = nmsgs * sizeof(SharedInvalidationMessage);
+			rdata[3].buffer = InvalidBuffer;
+			lastrdata = 3;
+		}
 		rdata[lastrdata].next = NULL;
 
 		(void) XLogInsert(RM_XACT_ID, XLOG_XACT_COMMIT, rdata);
@@ -1145,6 +1251,8 @@ AtSubCommit_childXids(void)
 	s->childXids = NULL;
 	s->nChildXids = 0;
 	s->maxChildXids = 0;
+	s->nReportedChildXids = 0;
+	s->reportedXid = false;
 }
 
 /* ----------------------------------------------------------------
@@ -1264,7 +1372,7 @@ RecordTransactionAbort(bool isSubXact)
 	 * main xacts, the equivalent happens just after this function returns.
 	 */
 	if (isSubXact)
-		XidCacheRemoveRunningXids(xid, nchildren, children, latestXid);
+		XidCacheRemoveRunningXids(MyProc, xid, nchildren, children, latestXid);
 
 	/* Reset XactLastRecEnd until the next transaction writes something */
 	if (!isSubXact)
@@ -1353,6 +1461,8 @@ AtSubAbort_childXids(void)
 	s->childXids = NULL;
 	s->nChildXids = 0;
 	s->maxChildXids = 0;
+	s->nReportedChildXids = 0;
+	s->reportedXid = false;
 }
 
 /* ----------------------------------------------------------------
@@ -1522,7 +1632,10 @@ StartTransaction(void)
 	s->gucNestLevel = 1;
 	s->childXids = NULL;
 	s->nChildXids = 0;
+	s->nReportedChildXids = 0;
+	s->reportedXid = false;
 	s->maxChildXids = 0;
+	s->startedInRecovery = RecoveryInProgress();
 	GetUserIdAndContext(&s->prevUser, &s->prevSecDefCxt);
 	/* SecurityDefinerContext should never be set outside a transaction */
 	Assert(!s->prevSecDefCxt);
@@ -1724,6 +1837,8 @@ CommitTransaction(void)
 	s->childXids = NULL;
 	s->nChildXids = 0;
 	s->maxChildXids = 0;
+	s->nReportedChildXids = 0;
+	s->reportedXid = false;
 
 	/*
 	 * done with commit processing, set current transaction state back to
@@ -1958,6 +2073,8 @@ PrepareTransaction(void)
 	s->childXids = NULL;
 	s->nChildXids = 0;
 	s->maxChildXids = 0;
+	s->nReportedChildXids = 0;
+	s->reportedXid = false;
 
 	/*
 	 * done with 1st phase commit processing, set current transaction state
@@ -2129,6 +2246,8 @@ CleanupTransaction(void)
 	s->childXids = NULL;
 	s->nChildXids = 0;
 	s->maxChildXids = 0;
+	s->nReportedChildXids = 0;
+	s->reportedXid = false;
 
 	/*
 	 * done with abort processing, set current transaction state back to
@@ -4207,33 +4326,298 @@ xactGetCommittedChildren(TransactionId **ptr)
 	return s->nChildXids;
 }
 
+static TransactionId *
+xactGetUnreportedChildren(int threshold, int *nxids)
+{
+	TransactionState s;
+	int nTotalUnreportedXids;
+	TransactionId *xids;
+
+	/* Count unreported xids in the tree */
+	for (s = CurrentTransactionState; s != NULL; s = s->parent)
+	{
+		if (!s->reportedXid)
+			nTotalUnreportedXids++;
+		nTotalUnreportedXids += s->nChildXids - s->nReportedChildXids;
+		if (s->reportedXid)
+			break;
+	}
+
+	*nxids = nTotalUnreportedXids;
+
+	if (nTotalUnreportedXids < threshold)
+		return NULL;
+
+	xids = (TransactionId *) palloc(sizeof(TransactionId) * nTotalUnreportedXids);
+	xactCollectUnreportedChildren(CurrentTransactionState, xids);
+	return xids;
+}
+
+/* Helper function for xactGetUnreportedChildren */
+static TransactionId *
+xactCollectUnreportedChildren(TransactionState s, TransactionId *xids)
+{
+	int nUnreportedChildXids;
+
+	if (s->parent != NULL)
+	{
+		xids = xactCollectUnreportedChildren(s->parent, xids);
+		if (!s->reportedXid)
+		{
+			s->reportedXid = true;
+			*(xids++) = s->transactionId;
+		}
+	}
+
+	nUnreportedChildXids = s->nChildXids - s->nReportedChildXids;
+	memcpy(xids, &s->childXids[s->nReportedChildXids],
+		   nUnreportedChildXids * sizeof(TransactionId));
+	xids += nUnreportedChildXids;
+
+	s->nReportedChildXids = s->nChildXids;
+
+	return xids;
+}
+
+/*
+ * Record an enhanced snapshot of running transactions into WAL.
+ */
+void
+LogCurrentRunningXacts(void)
+{
+	RunningTransactions		CurrRunningXacts = GetRunningTransactionData();
+	xl_xact_running_xacts	xlrec;
+	XLogRecData 			rdata[3];
+	int						lastrdata = 0;
+	XLogRecPtr				recptr;
+
+	xlrec.xcnt = CurrRunningXacts->xcnt;
+	xlrec.subxcnt = CurrRunningXacts->subxcnt;
+	xlrec.latestRunningXid = CurrRunningXacts->latestRunningXid;
+	xlrec.oldestRunningXid = CurrRunningXacts->oldestRunningXid;
+	xlrec.latestCompletedXid = CurrRunningXacts->latestCompletedXid;
+
+	/* Header */
+	rdata[0].data = (char *) (&xlrec);
+	rdata[0].len = MinSizeOfXactRunningXacts;
+	rdata[0].buffer = InvalidBuffer;
+
+	/* array of RunningXact */
+	if (xlrec.xcnt > 0)
+	{
+		rdata[0].next = &(rdata[1]);
+		rdata[1].data = (char *) CurrRunningXacts->xrun;
+		rdata[1].len = xlrec.xcnt * sizeof(RunningXact);
+		rdata[1].buffer = InvalidBuffer;
+		lastrdata = 1;
+	}
+
+	/* array of TransactionIds */
+	if (xlrec.subxcnt > 0)
+	{
+		rdata[lastrdata].next = &(rdata[2]);
+		rdata[2].data = (char *) CurrRunningXacts->subxip;
+		rdata[2].len = xlrec.subxcnt * sizeof(TransactionId);
+		rdata[2].buffer = InvalidBuffer;
+		lastrdata = 2;
+	}
+
+	rdata[lastrdata].next = NULL;
+
+	recptr = XLogInsert(RM_XACT_ID, XLOG_XACT_RUNNING_XACTS, rdata);
+
+	elog(trace_recovery(DEBUG2), "captured snapshot of running xacts %X/%X", recptr.xlogid, recptr.xrecoff);
+}
+
+/*
+ * We need to issue shared invalidations and hold locks. Holding locks
+ * means others may want to wait on us, so we need to make lock table
+ * inserts to appear like a transaction. We could create and delete
+ * lock table entries for each transaction but its simpler just to create
+ * one permanent entry and leave it there all the time. Locks are then
+ * acquired and released as needed. Yes, this means you can see the
+ * Startup process in pg_locks once we have run this.
+ */
+void
+InitRecoveryTransactionEnvironment(void)
+{
+	VirtualTransactionId vxid;
+
+	/*
+	 * Initialise shared invalidation management for Startup process,
+	 * being careful to register ourselves as a sendOnly process so
+	 * we don't need to read messages, nor will we get signalled
+	 * when the queue starts filling up.
+	 */
+	SharedInvalBackendInit(true);
+
+	/*
+	 * Record the PID and PGPROC structure of the startup process.
+	 */
+	PublishStartupProcessInformation();
+
+	/*
+	 * Lock a virtual transaction id for Startup process.
+	 *
+	 * We need to do GetNextLocalTransactionId() because
+	 * SharedInvalBackendInit() leaves localTransactionid invalid and
+	 * the lock manager doesn't like that at all.
+	 *
+	 * Note that we don't need to run XactLockTableInsert() because nobody
+	 * needs to wait on xids. That sounds a little strange, but table locks
+	 * are held by vxids and row level locks are held by xids. All queries
+	 * hold AccessShareLocks so never block while we write or lock new rows.
+	 */
+	vxid.backendId = MyBackendId;
+	vxid.localTransactionId = GetNextLocalTransactionId();
+	VirtualXactLockTableInsert(vxid);
+
+	/*
+	 * Now that the database is consistent we can create a valid copy of
+	 * the flat files required for connection and authentication. This
+	 * may already have been executed at appropriate commit points, but
+	 * we cannot trust that those executions were correct, so force it
+	 * again now just to be safe.
+	 */
+	BuildFlatFiles(false);
+}
+
+void
+XactClearRecoveryTransactions(void)
+{
+	/*
+	 * Remove entries from shared data structures
+	 */
+	UnobservedTransactionsClearXids();
+	RelationClearRecoveryLocks();
+}
+
+/*
+ * LatestRemovedXidAdvances - returns true if latestRemovedXid is moved
+ * 								forwards by the latest provided value
+ */
+bool
+LatestRemovedXidAdvances(TransactionId latestXid)
+{
+	/*
+	 * Don't bother checking for conflicts for cleanup records earlier than
+	 * we have already tested for.
+	 */
+	if (!TransactionIdIsValid(latestRemovedXid) ||
+		(TransactionIdIsValid(latestRemovedXid) &&
+		TransactionIdPrecedes(latestRemovedXid, latestXid)))
+	{
+		latestRemovedXid = latestXid;
+		return true;
+	}
+
+	return false;
+}
+
 /*
  *	XLOG support routines
  */
 
+/*
+ * Before 8.5 this was a fairly short function, but now it performs many
+ * actions for which the order of execution is critical.
+ */
 static void
-xact_redo_commit(xl_xact_commit *xlrec, TransactionId xid)
+xact_redo_commit(xl_xact_commit *xlrec, TransactionId xid, bool preparedXact)
 {
 	TransactionId *sub_xids;
 	TransactionId max_xid;
 	int			i;
 
-	/* Mark the transaction committed in pg_clog */
 	sub_xids = (TransactionId *) &(xlrec->xnodes[xlrec->nrels]);
+
+	max_xid = TransactionIdLatest(xid, xlrec->nsubxacts, sub_xids);
+
+	/* XXX: Is there any reason to mark (sub)transactions in unobserved
+	 * array that we're just about to mark as committed anyway?
+	  RecordKnownAssignedSubTransactionIds(max_xid, xlrec->nsubxacts, sub_xids);
+	*/
+
+	/* Mark the transaction committed in pg_clog */
 	TransactionIdCommitTree(xid, xlrec->nsubxacts, sub_xids);
 
-	/* Make sure nextXid is beyond any XID mentioned in the record */
-	max_xid = xid;
-	for (i = 0; i < xlrec->nsubxacts; i++)
+	if (InArchiveRecovery)
 	{
-		if (TransactionIdPrecedes(max_xid, sub_xids[i]))
-			max_xid = sub_xids[i];
+		/*
+		 * We must mark clog before we update the ProcArray.
+		 */
+		UnobservedTransactionsRemoveXids(xid, xlrec->nsubxacts, sub_xids);
+
+		if (preparedXact)
+		{
+			/*
+			 * Commit prepared xlog records do not carry invalidation data,
+			 * since this is already held within the two phase state file.
+			 * So we read it from there instead, with much the same effects.
+			 */
+			ProcessTwoPhaseStandbyRecords(xid);
+		}
+		else
+		{
+			/*
+			 * If requested, update the flat files for DB and Auth Files by
+			 * reading the catalog tables. Needs to be the first action taken
+			 * after marking transaction complete to minimise race conditions.
+			 * This is the opposite way round to the original actions, which
+			 * update the files and then mark committed, so there is a race
+			 * condition in both places.
+			 */
+			if (XactCompletionUpdateDBFile(xlrec) ||
+				XactCompletionUpdateAuthFile(xlrec))
+			{
+				if (XactCompletionUpdateAuthFile(xlrec))
+					BuildFlatFiles(false);
+				else
+					BuildFlatFiles(true);
+			}
+
+			/*
+			 * Send any cache invalidations attached to the commit. We must
+			 * maintain the same order of invalidation then release locks
+			 * as occurs in RecordTransactionCommit.
+			 */
+			if (xlrec->nmsgs > 0)
+			{
+				int	offset = OffsetSharedInvalInXactCommit();
+				SharedInvalidationMessage *msgs = (SharedInvalidationMessage *)
+								(((char *) xlrec) + offset);
+
+				SendSharedInvalidMessages(msgs, xlrec->nmsgs);
+			}
+		}
+
+		/*
+		 * Release locks, if any.
+		 */
+		RelationReleaseRecoveryLockTree(xid, xlrec->nsubxacts, sub_xids);
 	}
+
+	/* Make sure nextXid is beyond any XID mentioned in the record */
+	/* XXX: We don't expect anyone else to modify nextXid, hence we
+	 * don't need to hold a lock while checking this. We still acquire
+	 * the lock to modify it, though.
+	 */
 	if (TransactionIdFollowsOrEquals(max_xid,
 									 ShmemVariableCache->nextXid))
 	{
+		LWLockAcquire(XidGenLock, LW_EXCLUSIVE);
 		ShmemVariableCache->nextXid = max_xid;
 		TransactionIdAdvance(ShmemVariableCache->nextXid);
+		LWLockRelease(XidGenLock);
+	}
+
+	/* XXX: Same here, don't use lock to test, but need one to modify */
+	if (TransactionIdFollowsOrEquals(max_xid,
+									 ShmemVariableCache->latestCompletedXid))
+	{
+		LWLockAcquire(ProcArrayLock, LW_EXCLUSIVE);
+		ShmemVariableCache->latestCompletedXid = max_xid;
+		LWLockRelease(ProcArrayLock);
 	}
 
 	/* Make sure files supposed to be dropped are dropped */
@@ -4254,6 +4638,15 @@ xact_redo_commit(xl_xact_commit *xlrec, TransactionId xid)
 	}
 }
 
+/*
+ * Be careful with the order of execution, as with xact_redo_commit().
+ * The two functions are similar but differ in key places.
+ *
+ * Note also that an abort can be for a subtransaction and its children,
+ * not just for a top level abort. That means we have to consider
+ * topxid != xid, whereas in commit we would find topxid == xid always
+ * because subtransaction commit is never WAL logged.
+ */
 static void
 xact_redo_abort(xl_xact_abort *xlrec, TransactionId xid)
 {
@@ -4261,21 +4654,40 @@ xact_redo_abort(xl_xact_abort *xlrec, TransactionId xid)
 	TransactionId max_xid;
 	int			i;
 
-	/* Mark the transaction aborted in pg_clog */
 	sub_xids = (TransactionId *) &(xlrec->xnodes[xlrec->nrels]);
+	max_xid = TransactionIdLatest(xid, xlrec->nsubxacts, sub_xids);
+
+/* XXX same as commit
+	RecordKnownAssignedSubTransactionIds(max_xid, xlrec->nsubxacts, sub_xids);
+*/
+
+	/* Mark the transaction aborted in pg_clog */
 	TransactionIdAbortTree(xid, xlrec->nsubxacts, sub_xids);
 
-	/* Make sure nextXid is beyond any XID mentioned in the record */
-	max_xid = xid;
-	for (i = 0; i < xlrec->nsubxacts; i++)
+	if (InArchiveRecovery)
 	{
-		if (TransactionIdPrecedes(max_xid, sub_xids[i]))
-			max_xid = sub_xids[i];
+		/*
+		 * We must mark clog before we update the ProcArray.
+		 */
+		UnobservedTransactionsRemoveXids(xid, xlrec->nsubxacts, sub_xids);
+
+		/*
+		 * There are no flat files that need updating, nor invalidation
+		 * messages to send or undo.
+		 */
+
+		/*
+		 * Release locks, if any. There are no invalidations to send.
+		 */
+		RelationReleaseRecoveryLockTree(xid, xlrec->nsubxacts, sub_xids);
 	}
+
+	/* Make sure nextXid is beyond any XID mentioned in the record */
 	if (TransactionIdFollowsOrEquals(max_xid,
 									 ShmemVariableCache->nextXid))
 	{
 		ShmemVariableCache->nextXid = max_xid;
+		ShmemVariableCache->latestCompletedXid = ShmemVariableCache->nextXid;
 		TransactionIdAdvance(ShmemVariableCache->nextXid);
 	}
 
@@ -4297,6 +4709,54 @@ xact_redo_abort(xl_xact_abort *xlrec, TransactionId xid)
 	}
 }
 
+static void
+xact_redo_assignment(XLogRecPtr lsn, XLogRecord *record)
+{
+	xl_xact_assignment *xlrec = (xl_xact_assignment *) XLogRecGetData(record);
+	int nsubxids = (record->xl_len - offsetof(xl_xact_assignment, xsub)) /
+		sizeof(TransactionId);
+	int i;
+
+	Assert(nsubxids > 0);
+
+	if (!InArchiveRecovery)
+		return;
+
+	/*
+	 * Notice that we update pg_subtrans with the top-level xid, rather
+	 * than the parent xid. This is a difference between normal
+	 * processing and recovery, yet is still correct in all cases. The
+	 * reason is that subtransaction commit is not marked in clog until
+	 * commit processing, so all aborted subtransactions have already been
+	 * clearly marked in clog. As a result we are able to refer directly
+	 * to the top-level transaction's state rather than skipping through
+	 * all the intermediate states in the subtransaction tree.
+	 */
+	for (i = 0; i < nsubxids; i++)
+	{
+		TransactionId subxid = xlrec->xsub[i];
+
+		ExtendSUBTRANS(subxid);
+		SubTransSetParent(subxid, xlrec->xtop);
+		/*
+		 * XXX: As long as there's room in the unobserved xids array, we
+		 * could add entries there. But we don't know if there is, and
+		 * then we'd have to keep track of subxids in the array that we
+		 * could remove later on if the array fills up
+		 *
+		  RecordKnownAssignedTransactionXids(lsn, subxid);
+		*/
+	}
+
+	/*
+	 * Remove the subxids from the array, now that they have their parents
+	 * set correctly in subtrans.
+	 */
+	AdvanceLastOverflowedUnobservedXid(xlrec->xsub[nsubxids - 1]);
+	UnobservedTransactionsRemoveXids(InvalidTransactionId, nsubxids,
+									xlrec->xsub);
+}
+
 void
 xact_redo(XLogRecPtr lsn, XLogRecord *record)
 {
@@ -4305,11 +4765,43 @@ xact_redo(XLogRecPtr lsn, XLogRecord *record)
 	/* Backup blocks are not used in xact records */
 	Assert(!(record->xl_info & XLR_BKP_BLOCK_MASK));
 
+	if (info == XLOG_XACT_ASSIGNMENT)
+	{
+		xact_redo_assignment(lsn, record);
+		return;
+	}
+	else if (info == XLOG_XACT_RUNNING_XACTS)
+	{
+		xl_xact_running_xacts *xlrec = (xl_xact_running_xacts *) XLogRecGetData(record);
+
+		/*
+		 * If RunningXact data is complete then apply it.
+		 *
+		 * XLOG_XACT_RUNNING_XACTS initialises the first snapshot, if
+		 * InHotStandby. It also cross-checks
+		 * the contents of recovery procs in case of FATAL errors as
+		 * recovery progresses.
+		 */
+		if (InHotStandby &&
+			TransactionIdIsValid(xlrec->latestRunningXid))
+			ProcArrayUpdateRecoveryTransactions(lsn, xlrec);
+
+		return;
+	}
+
+	if (InArchiveRecovery)
+	{
+		/*
+		 * No conflict resolution is required for transaction completion records
+		 */
+		(void) RecordKnownAssignedTransactionIds(lsn, record->xl_xid);
+	}
+
 	if (info == XLOG_XACT_COMMIT)
 	{
 		xl_xact_commit *xlrec = (xl_xact_commit *) XLogRecGetData(record);
 
-		xact_redo_commit(xlrec, record->xl_xid);
+		xact_redo_commit(xlrec, record->xl_xid, false);
 	}
 	else if (info == XLOG_XACT_ABORT)
 	{
@@ -4327,7 +4819,7 @@ xact_redo(XLogRecPtr lsn, XLogRecord *record)
 	{
 		xl_xact_commit_prepared *xlrec = (xl_xact_commit_prepared *) XLogRecGetData(record);
 
-		xact_redo_commit(&xlrec->crec, xlrec->xid);
+		xact_redo_commit(&xlrec->crec, xlrec->xid, true);
 		RemoveTwoPhaseFile(xlrec->xid, false);
 	}
 	else if (info == XLOG_XACT_ABORT_PREPARED)
@@ -4346,10 +4838,19 @@ xact_desc_commit(StringInfo buf, xl_xact_commit *xlrec)
 {
 	int			i;
 
+	if (XactCompletionUpdateDBFile(xlrec))
+		appendStringInfo(buf, "; update db file");
+
+	if (XactCompletionUpdateDBFile(xlrec))
+		appendStringInfo(buf, "; update auth file");
+
+	if (XactCompletionRelcacheInitFileInval(xlrec))
+		appendStringInfo(buf, "; relcache init file inval");
+
 	appendStringInfoString(buf, timestamptz_to_str(xlrec->xact_time));
 	if (xlrec->nrels > 0)
 	{
-		appendStringInfo(buf, "; rels:");
+		appendStringInfo(buf, "; %d rels:", xlrec->nrels);
 		for (i = 0; i < xlrec->nrels; i++)
 		{
 			char	   *path = relpath(xlrec->xnodes[i], MAIN_FORKNUM);
@@ -4361,12 +4862,34 @@ xact_desc_commit(StringInfo buf, xl_xact_commit *xlrec)
 	if (xlrec->nsubxacts > 0)
 	{
 		TransactionId *xacts = (TransactionId *)
-		&xlrec->xnodes[xlrec->nrels];
-
-		appendStringInfo(buf, "; subxacts:");
+									&xlrec->xnodes[xlrec->nrels];
+		appendStringInfo(buf, "; %d subxacts:", xlrec->nsubxacts);
 		for (i = 0; i < xlrec->nsubxacts; i++)
 			appendStringInfo(buf, " %u", xacts[i]);
 	}
+	if (xlrec->nmsgs > 0)
+	{
+		/*
+		 * The invalidation messages are the third variable length array
+		 * from the start of the record. The record header has everything
+		 * we need to calculate where that starts.
+		 */
+		int	offset = OffsetSharedInvalInXactCommit();
+		SharedInvalidationMessage *msgs = (SharedInvalidationMessage *)
+						(((char *) xlrec) + offset);
+		appendStringInfo(buf, "; %d inval msgs:", xlrec->nmsgs);
+		for (i = 0; i < xlrec->nmsgs; i++)
+		{
+			SharedInvalidationMessage *msg = msgs + i;
+
+			if (msg->id >= 0)
+				appendStringInfo(buf,  "catcache id%d ", msg->id);
+			else if (msg->id == SHAREDINVALRELCACHE_ID)
+				appendStringInfo(buf,  "relcache ");
+			else if (msg->id == SHAREDINVALSMGR_ID)
+				appendStringInfo(buf,  "smgr ");
+		}
+	}
 }
 
 static void
@@ -4389,14 +4912,51 @@ xact_desc_abort(StringInfo buf, xl_xact_abort *xlrec)
 	if (xlrec->nsubxacts > 0)
 	{
 		TransactionId *xacts = (TransactionId *)
-		&xlrec->xnodes[xlrec->nrels];
+									&xlrec->xnodes[xlrec->nrels];
 
-		appendStringInfo(buf, "; subxacts:");
+		appendStringInfo(buf, "; %d subxacts:", xlrec->nsubxacts);
 		for (i = 0; i < xlrec->nsubxacts; i++)
 			appendStringInfo(buf, " %u", xacts[i]);
 	}
 }
 
+static void
+xact_desc_running_xacts(StringInfo buf, xl_xact_running_xacts *xlrec)
+{
+	int				xid_index,
+					subxid_index;
+	TransactionId 	*subxip = (TransactionId *) &(xlrec->xrun[xlrec->xcnt]);
+
+	appendStringInfo(buf, "nxids %u nsubxids %u latestRunningXid %d",
+								xlrec->xcnt,
+								xlrec->subxcnt,
+								xlrec->latestRunningXid);
+
+	appendStringInfo(buf, " oldestRunningXid %d latestCompletedXid %d",
+								xlrec->oldestRunningXid,
+								xlrec->latestCompletedXid);
+
+	for (xid_index = 0; xid_index < xlrec->xcnt; xid_index++)
+	{
+		RunningXact		*rxact = (RunningXact *) xlrec->xrun;
+
+		appendStringInfo(buf, "; xid %d", rxact[xid_index].xid);
+
+		if (rxact[xid_index].nsubxids > 0)
+		{
+			appendStringInfo(buf, " nsubxids %u offset %d ovflow? %s",
+									rxact[xid_index].nsubxids,
+									rxact[xid_index].subx_offset,
+									(rxact[xid_index].overflowed ? "t" : "f"));
+
+			appendStringInfo(buf, "; subxacts: ");
+			for (subxid_index = 0; subxid_index < rxact[xid_index].nsubxids; subxid_index++)
+				appendStringInfo(buf, " %u",
+						subxip[subxid_index + rxact[xid_index].subx_offset]);
+		}
+	}
+}
+
 void
 xact_desc(StringInfo buf, uint8 xl_info, char *rec)
 {
@@ -4424,16 +4984,31 @@ xact_desc(StringInfo buf, uint8 xl_info, char *rec)
 	{
 		xl_xact_commit_prepared *xlrec = (xl_xact_commit_prepared *) rec;
 
-		appendStringInfo(buf, "commit %u: ", xlrec->xid);
+		appendStringInfo(buf, "commit prepared %u: ", xlrec->xid);
 		xact_desc_commit(buf, &xlrec->crec);
 	}
 	else if (info == XLOG_XACT_ABORT_PREPARED)
 	{
 		xl_xact_abort_prepared *xlrec = (xl_xact_abort_prepared *) rec;
 
-		appendStringInfo(buf, "abort %u: ", xlrec->xid);
+		appendStringInfo(buf, "abort prepared %u: ", xlrec->xid);
 		xact_desc_abort(buf, &xlrec->arec);
 	}
+	else if (info == XLOG_XACT_ASSIGNMENT)
+	{
+		xl_xact_assignment *xlrec = (xl_xact_assignment *) rec;
+
+		/* ignore the main xid, it may be Invalid and misleading */
+		appendStringInfo(buf, "assignment: xtop %u XXX subxids",
+							xlrec->xtop);
+	}
+	else if (info == XLOG_XACT_RUNNING_XACTS)
+	{
+		xl_xact_running_xacts *xlrec = (xl_xact_running_xacts *) rec;
+
+		appendStringInfo(buf, "running xacts: ");
+		xact_desc_running_xacts(buf, xlrec);
+	}
 	else
 		appendStringInfo(buf, "UNKNOWN");
 }
